// dont forget to add pico_multicore in the target_link_libraries
// target_link_libraries(MCP4821dualCoreDDSconsoleViaUARTv01 pico_stdlib pico_multicore)
// CMakeLists.txt
// https://learnembeddedsystems.co.uk/basic-multicore-pico-example

#include <stdio.h>
#include <math.h>
#include "pico/stdlib.h"
#include "pico/multicore.h"
//#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\pico_multicore\include\pico\multicore.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\include\hardware\spi.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\spi.c>


/*
   GPIO 16 (pin 21) MISO
   GPIO 17 (pin 22) CS
   GPIO 18 (pin 24) SCK
   GPIO 19 (pin 25) MOSI
   3.3v (pin 36) -> VCC
   GND (pin 38)  -> GND
*/

#define PWM_PIN1 2    // GPIO2 pin 4
#define PWM_PIN2 3    // GPIO3 pin 5
#define GPIO4 4     // pin 6    

#define TFT_MISO 16 
#define TFT_CS 17 
#define TFT_SCK 18
#define TFT_MOSI 19 


#include "core1.c"


//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
#define spiFIFOsize 256
#define spiFIFOmask (spiFIFOsize-1)

int spiFIFO[spiFIFOsize] ;
int spiFIFOinPtr ;
int spiFIFOoutPtr ;

void spiFIFOinit(){
  spiFIFOinPtr=0 ;
  spiFIFOoutPtr=1 ;
  }

uint16_t spiBuf16[2];
volatile int spiData ;
volatile int spiFetched ;

int spiFIFOfull(){
  int state ;
  int flag ;
  state=save_and_disable_interrupts () ;
  flag= spiFIFOinPtr==spiFIFOoutPtr ;
  restore_interrupts (state) ;
  return flag ;
  }

#define nSHDN 1 
#define nGA   1 

void on_pwm_wrap() {
  // gpio_put(GPIO4, 1);
  spiBuf16[0] =spiData | (nSHDN<<12) | (nGA<<13)  ;
  // Clear the interrupt flag that brought us here
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  spi_write16_blocking(spi_default, spiBuf16, 1);
  spiData=spiFIFO[spiFIFOoutPtr] ;
  spiFIFOoutPtr=(spiFIFOoutPtr+1) & spiFIFOmask ;

  //spiData=(2048+ multicore_fifo_pop_blocking());
 // printf("s=%10d\n",spiData) ;
  //gpio_put(GPIO4, 0);
  }

//-----------------------------------------------------------------------------------

void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
  gpio_set_function(PWM_PIN2, GPIO_FUNC_PWM);
   // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
  uint slice_num2 = pwm_gpio_to_slice_num(PWM_PIN2);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler
  pwm_clear_irq(slice_num1);
  pwm_set_irq_enabled(slice_num1, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
  irq_set_enabled(PWM_IRQ_WRAP, true);
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_output_polarity (&config1,1,0) ; // invert A channel

  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  // Set period of 125 cycles (0 to 124 inclusive)
  //pwm_set_wrap(slice_num1,124 );
  #define clkDiv 625
  //#define clkDiv 250
  pwm_set_wrap(slice_num1,(clkDiv-1) );
  sampleFrequency=125e6/clkDiv/1.0 ;
  printf("sampleFrequency=%15.5f\n",sampleFrequency) ;
  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  
  printf("PWM_PIN2=%d\n",PWM_PIN2) ;
  printf("slice_num2=%d\n",slice_num2) ;

  printf("config1=%d\n",config1) ;
  printf("\n") ;
  }

inline void putSample(int v){
  // gpio_put(gpio4, 1);
  while(spiFIFOfull() ){}
  // gpio_put(gpio4, 0);
  spiFIFO[spiFIFOinPtr]=v ;
  spiFIFOinPtr=(spiFIFOinPtr+1) & spiFIFOmask ;
  }

int main() {
  stdio_init_all();
  printf("Hello, RDSgeneratorDualCoreV01 !\n");
  multicore_launch_core1(core1_entry);

  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);
  //gpio_set_drive_strength(GPIO4,GPIO_DRIVE_STRENGTH_12MA) ;

  gpio_init(TFT_CS);
  gpio_set_dir(TFT_CS, GPIO_OUT);
  gpio_put(TFT_CS, 1);
  
  spi_init(spi_default,  24000000);
  // gpio_set_function(PICO_DEFAULT_SPI_RX_PIN, GPIO_FUNC_SPI);
  gpio_set_function(PICO_DEFAULT_SPI_SCK_PIN, GPIO_FUNC_SPI);
  gpio_set_function(PICO_DEFAULT_SPI_TX_PIN, GPIO_FUNC_SPI);
  spi_set_format(spi_default,16,0,0,SPI_MSB_FIRST) ;

  PWMsetup() ;
  pwm_set_gpio_level(PWM_PIN1, 500);
  pwm_set_gpio_level(PWM_PIN2, 400);
   
  while(1){
    int data=(2048+ multicore_fifo_pop_blocking());
    putSample(data) ;
    }
 
  }



