
float twopi = 3.1415926535 * 2;
int DDStable[4096] ;

float sampleFrequency  ; 
#define Tone1FRQ (1e3)
int Tone1ddsFrequency ;
int Tone1ddsPhase ;

#define Tone2FRQ (2.5e3)
int Tone2ddsFrequency ;
int Tone2ddsPhase ;

#define nSHDN 1 
#define nGA   1 

//------------------------------------------------------------------------------------------------------

uint m_z=1234 ;
uint m_w=3456 ;

inline uint getRand(){
  m_z = 36969 * (m_z & 65535) + (m_z >> 16);
  m_w = 18000 * (m_w & 65535) + (m_w >> 16);
  //return (m_z << 16) + m_w;  
  return m_w;  
  }

float frand(){
   int r=getRand() % 0xFFFF ;
   return r/65536.0 ;
}

void initRand(){
  m_z=1234 ;
  m_w=3456 ;
  for(int k=0 ; k<32 ; k++){ 
     printf("rand()=%15d\n",getRand()) ; 
     }
  } 

//------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------

#define nFFT 16384
float fftRe[nFFT] ;
float fftIm[nFFT] ;

void fft(int flag , float scale ) {
    int j,k,l,m,m1,n1,r,r1,r2 ;
    float re,im,a,b,ru,rv,iu,iv,rs ;
   
    m1=nFFT / 2 ;
    n1=round(log(nFFT)/log(2)) ;
    //printf("log(nFFT)=%10.5f log(2)=%10.5f\n",log(nFFT),log(2)) ;
    //printf("nFFT=%4d n1=%4d \n",nFFT,n1) ;
    // abort() ;
    l=0 ;
    for ( k=0 ; k<nFFT ; k++){
       if ( k>l ) { 
         re=fftRe[l] ; 
         im=fftIm[l] ; 
         fftRe[l]=fftRe[k] ; 
         fftIm[l]=fftIm[k] ;
         fftRe[k]=re ; 
         fftIm[k]=im ;
         }
       j=m1 ;
       while( (j<=l) & (j>0) ){  l=l-j ; j=j / 2 ; }
       l=l+j ;
       }
     //printf("hello 2\n") ;
     //abort() ;  
     m1=1 ;
     for ( m=1 ; m<=n1 ; m++){
       //printf("m1=%4d\n",m1) ;
       a=cos(M_PI/m1) ; 
       b=flag*sin(M_PI/m1) ; 
       re=1 ; 
       im=0 ;
       for ( j=0 ; j<m1 ; j++){
       r=0 ;
        while ( r<=nFFT-1 ){ 
        r1=r+j ; r2=r1+m1 ;
        ru=fftRe[r1] ; iu=fftIm[r1] ;
        rv=fftRe[r2]*re-fftIm[r2]*im ;
        iv=fftRe[r2]*im+fftIm[r2]*re ;
        fftRe[r1]=ru+rv ; fftIm[r1]=iu+iv ;
        fftRe[r2]=ru-rv ; fftIm[r2]=iu-iv ;
        r=r+2*m1 ;
        }
      rs=a*re-b*im ; 
      im=a*im+b*re ;
      re=rs ;
      }
    m1=2*m1 ;
    }
    //printf("hello 3\n") ;
    // abort() ; 
    for( k=0 ; k<nFFT ; k++) {
      fftRe[k]=scale*fftRe[k] ; 
      fftIm[k]=scale*fftIm[k] ;
      }
    //printf("hello 4\n") ;
    }


//------------------------------------------------------------------------------------------------------
/*
float fabs(float x){
  if(x<0){ return -x ; }
  return x ;
  }
*/
float sqr(float x){ return x*x ; }

int signal[nFFT] ;

float fSample ;


void setSpectrum(float f1, float f2, float amplitude){
  int k1=(int)f1/(fSample/nFFT) ;
  int k2=(int)f2/(fSample/nFFT)  ;
  float phi=0 ;
  for(int k=k1 ; k<k2 ; k++ ){ 
    phi= frand()*2.0*M_PI ; 
    fftRe[k]=amplitude*cos(phi) ; 
    fftIm[k]=amplitude*sin(phi) ;
    } 
  }

void setSignal(){
  for(int k=0 ; k<nFFT ; k++){
    fftRe[k]=0.0 ;
    fftIm[k]=0.0 ;
    }

  fSample=125e6/PWMclkDiv ;
 
 if(1){
  setSpectrum(10e3,15e3,1.0) ;
  setSpectrum(20e3,25e3,0.1) ;
  setSpectrum(30e3,35e3,0.01) ;
  }


  for(int k=1 ; k<nFFT/2 ; k++){
    fftRe[nFFT-k]=fftRe[k] ;
    fftIm[nFFT-k]=-fftIm[k] ;
    }
  fft(1,1.0) ;
  float sMax=0 ;
  int mm=20 ;
  for(int k=0 ; k<nFFT ; k++){
    if((k<mm)|(k>nFFT-mm)) { printf("k=%5d Re=%10.5f Im=%10.5f\n",k,fftRe[k],fftIm[k]) ; }
    if(fabs(fftRe[k])>sMax) { sMax=fabs(fftRe[k]) ; }
    }
  printf("sMax=%10.5f\n",sMax) ;  
  float sMaxWanted=1800 ;  
  for(int k=0 ; k<nFFT ; k++){
    signal[k]=2048+(int)(sMaxWanted/sMax*fftRe[k]) ;
    signal[k]=signal[k] | (nSHDN<<12) | (nGA<<13) ;
    }
 
  }


//------------------------------------------------------------------------------------------------------

void core1_entry() {
  printf("Hello, multicore core1_entry DDS generator()!\n");
  initRand() ;
  for(int k=0 ; k<4096 ; k++){
    DDStable[k]=1000*sin(twopi*k/4096.0) ;
   // if(DDStable[k]>0){ DDStable[k]=1000 ;} else { DDStable[k]=-1000 ;}
    }
 
  Tone1ddsPhase=0 ;
  Tone1ddsFrequency=Tone1FRQ/sampleFrequency*(double)(0x100000000L) ;

  Tone2ddsPhase=0 ;
  Tone2ddsFrequency=Tone2FRQ/sampleFrequency*(double)(0x100000000L) ;
 

  if(0){
  while(1){
    gpio_put(GPIO4, 1);
    int nextVal= DDStable[ (Tone1ddsPhase >> 20 ) & 0xFFF ] ;
   // int nextVal= DDStable[ (Tone1ddsPhase >> 20 ) & 0xFFF ] 
   //            + DDStable[ (Tone2ddsPhase >> 20 ) & 0xFFF ] ;
    Tone1ddsPhase=Tone1ddsPhase+Tone1ddsFrequency ;
   // Tone2ddsPhase=Tone2ddsPhase+Tone2ddsFrequency ;
    gpio_put(GPIO4, 0);
    multicore_fifo_push_blocking( nextVal ) ;
    }}

  setSignal() ;
  while(1){
    for(int k=0 ; k<nFFT ; k++ ){
      int nextVal=signal[k] ;
      multicore_fifo_push_blocking( nextVal ) ;
      }
    }
  
  }

