void abort(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }

void showMean(){
  adc_fifo_setup(true, false, 0, false, false);
  adc_run(true);
  int adcMean=0 ;
  for(int k=0 ; k<10000 ; k++){
    adcMean += adc_fifo_get_blocking();
    }
  adcMean=adcMean/10000 ;
  printf("adcMean=%d\n",adcMean) ;
  }

float sqr(float x){
  return x*x ;
  }

void fft1(int flag , double scale ) {
    //{ switch to DFT procedure if N not power of 2 }
  //for(int k=0 ; k<n ; k++) {
  //  System.out.println(String.format(" input re/im = %10.5f +im %10.5f",fftRe[k],fftIm[k])) ;
  //  }    
    int j,k,l,m,m1,n1,r,r1,r2 ;
    double re,im,a,b,ru,rv,iu,iv,rs ;
    double check ;
    double *intPtr ;
   
   /*
    printf("FFT input:\n") ;
    for(int k=8192 ; k<8212 ; k++){
      printf("k=%4d Re=%10.5f Im=%10.5f\n",k,fftRe[k],fftIm[k]) ;
      }
*/

    check=modf(log(nFFT)/log(2)+1.0e-5,intPtr) ;
    //System.out.println("check="+check) ;
    if ( fabs(check)>1.0e-4 ){
      printf("Error: cant switch to dft n=%d\n",nFFT);
      abort() ;
      }
     else{
     m1=nFFT / 2 ;
     n1=round(log(nFFT)/log(2)) ;
     //System.out.println(" n="+n+" n1="+n1) ;
     l=0 ;
     for ( k=0 ; k<nFFT ; k++){
       if ( k>l ) { 
         re=fftRe[l] ; 
         im=fftIm[l] ; 
         fftRe[l]=fftRe[k] ; 
         fftIm[l]=fftIm[k] ;
         fftRe[k]=re ; 
         fftIm[k]=im ;
         }
       j=m1 ;
       while( (j<=l) & (j>0) ){  l=l-j ; j=j / 2 ; }
       l=l+j ;
       }
     m1=1 ;
     for ( m=1 ; m<=n1 ; m++){
       a=cos(M_PI/m1) ; 
       b=flag*sin(M_PI/m1) ; 
       re=1 ; 
       im=0 ;
       for ( j=0 ; j<m1 ; j++){
       r=0 ;
        while ( r<=nFFT-1 ){ 
        r1=r+j ; r2=r1+m1 ;
        ru=fftRe[r1] ; iu=fftIm[r1] ;
        rv=fftRe[r2]*re-fftIm[r2]*im ;
        iv=fftRe[r2]*im+fftIm[r2]*re ;
        fftRe[r1]=ru+rv ; fftIm[r1]=iu+iv ;
        fftRe[r2]=ru-rv ; fftIm[r2]=iu-iv ;
        r=r+2*m1 ;
        }
      rs=a*re-b*im ; 
      im=a*im+b*re ;
      re=rs ;
      }
    m1=2*m1 ;
    }
    for( k=0 ; k<nFFT ; k++) {
      fftRe[k]=scale*fftRe[k] ; 
      fftIm[k]=scale*fftIm[k] ;
      //System.out.println(String.format(" re/im = %10.5f +im %10.5f",fftRe[k],fftIm[k])) ;
      }
    }
  }
  
void windowedFFT(int flag , double scale ){
/*
  printf("FFT scale = %10.5f\n",scale) ;
  printf("windowed FFT input:\n") ;
    for(int k=8192 ; k<8212 ; k++){
      printf("k=%4d Re=%10.5f Im=%10.5f\n",k,fftRe[k],fftIm[k]) ;
      }
*/
  for(int k=0 ; k<nFFT ; k++){
    //double w=0.54-0.46*Math.cos(2*Math.PI*k/(nFFT-1)) ;
    //double w=0.5-0.5*cos(2*M_PI*k/(nFFT-1)) ;
    //double w=1.0 ;
      
    double alpha=0.16 ;
    double a0=(1-alpha)/2 ;
    double a1=0.5 ;
    double a2=alpha/2 ;
    double w=a0-a1*cos(2*M_PI*k/(nFFT-1))+a2*cos(4*M_PI*k/(nFFT-1)) ;
      
    fftRe[k]=fftRe[k]*w;
    fftIm[k]=fftIm[k]*w;
    }
  fft1(flag ,scale) ;
  }

float getAmplitude(float f){
  if(f<0){ f=fFFTsample-f ; }
  int kf=(int)( f/fSample*nFFT) ;
  if(kf<0){ return 0 ; }
  if(kf>nFFT){ return 0 ; }
  return sqrt(sqr(fftRe[kf])+sqr(fftIm[kf])) ;
  }

//-----------------------------------------------------------------------------------
#define maxsec 50 
#define maxfil 10 

float a0[maxfil]  ;
int secstart[maxfil] ;
int seccnt[maxfil] ;

float w1[maxsec] ;

float w2[maxsec] ;
float a1[maxsec] ;
float a2[maxsec] ;
float b1[maxsec] ;
float b2[maxsec] ;
int filtop=0 ;
int sectop=0  ;

int butter(int nord, float frq){
int i,nsec ; 
float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;

if ((nord % 2)!=0){ printf("nord wrong in Tscheby") ; }
filtop++ ;
if( filtop>maxfil){ printf("maxfil error") ; }
nsec=nord / 2 ;
secstart[filtop]=sectop+1 ;
seccnt[filtop]=nsec ;
printf("butterworth filter, no=%d\n",filtop) ;
printf("ord=%d number of sections is %d\n",nord,nsec) ;
a0x=1.0 ;
for( i=nord ; i< 3*nsec ; i++){
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  printf("t=%10.4f  w=%10.4f\n",t,w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  sectop++ ;
  b1[sectop]=-2*u ;
  b2[sectop]=u*u+v*v ;
  printf("b1=%10.4f b2=%10.4f\n",b1[sectop],b2[sectop]) ;
  a1[sectop]=2 ; 
  a2[sectop]=1 ;
  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
  }
printf("a0=%10.4f\n",a0x) ;
a0[filtop]=a0x ;
return filtop ;
}

void tpreset(int filno){ 
  int i ;
  printf("reset filter with no=%d\n",filno) ;
  for (i=secstart[filno] ; i<secstart[filno]+seccnt[filno] ; i++){
  w1[i]=0 ; 
  w2[i]=0 ; 
  printf("clear section %d\n",i) ;
  }
}

float tprun(int filno, float x){
  int i ; 
  float w,w11,w22,y ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    w11=w1[i] ; w22=w2[i] ;
    w=x-b1[i]*w11-b2[i]*w22 ;
    y=w+a1[i]*w11+a2[i]*w22 ;
    w2[i]=w11 ; w1[i]=w ; x=y ;
    }
  return a0[filno]*y ;
  }

//---------------------------------------------------------------
int LOsinTab[256] ;
int LOcosTab[256] ;

void sigSetup(){
  for(int k=0 ; k<256 ; k++){
    double phi=2*M_PI*k/256.0 ;
    LOcosTab[k]=LOscale*cos(phi) ;
    LOsinTab[k]=LOscale*sin(phi) ;
    }
  }