
#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>
#include "hardware/resets.h"


void restore_interrupts 	( 	uint32_t  	status	) 	;
uint32_t save_and_disable_interrupts 	( 	void  		) ;	

// adc input adc2= GPIO28 pin 34
#define GPIO4 4
int toggle ;

uint32_t mixDDSp ;
uint32_t mixDDSd ;
uint32_t simDDSp ;
uint32_t simDDSd ;

/*
float fMix=198000.0 ;
float fSim=20000.0 ;
float fCursor1=-100 ;
float fCursor2= 100 ;

float fMin=-500 ;
float fMax= 500 ;
float fSample ;
float fFFTsample ;

#define nFFT 2048
#define nDown 500
#define scale1 1000.0
#define LOscale 1000
#define displayMax 1
*/

float fMix=0 ;
//float fMix=147300 ;
//float fMix=198000 ;
//float fMix=77500 ;
//float fMix=62500 ;
//float fMix=0 ;
float fSim=0 ;

/*float fCursor1=-5000 ;
float fCursor2=+5000 ;
float fMin=-20000 ;
float fMax=+20000 ;
*/
float fCursor1=162000 ;
float fCursor2=172000 ;
float fMin=0 ;
float fMax=250000 ;

float fSample ;
float fFFTsample ;

#define nFFT 4096  // max 16384
#define nDown 1
#define scale1 1000.0
#define LOscale 1000
#define displayMax 1
#define downSum 1

float fftRe[nFFT] ;
float fftIm[nFFT] ;
float fftMax[nFFT] ;
/*
float fCursor1=-100 ;
float fCursor2=100 ;
float fMin=-500 ;
float fMax=500 ;

float fSample ;
float fFFTsample ;

#define nFFT 16384  // max 16384
#define nDown 16
#define scale1 1000.0
#define LOscale 1000
#define displayMax 1
#define downSum 1

float fftRe[nFFT] ;
float fftIm[nFFT] ;
float fftMax[nFFT] ;
*/

int IIfil ;
int QQfil ;
//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;

//-----------------------------------------------------------------------------------

static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<5 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(1000) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

#include "tftLib1.c"
#include "graphTerm1.c"
#include "sigLib1.c"

//-----------------------------------------------------------------------------------

void uart_putc1(char c){
  printf("%c",c) ;
  }

void uart_puts1 (char *s){
  while (*s){   
    uart_putc1(*s);
    s++;
    }
  }

void uart_blank(){
  uart_putc1(' ') ; 
  }

void uart_crlf(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void uart_cr(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void decout(int k){
  // uart_putc1(32) ;
  uart_putc1( ((k/1000) % 10)+48 ) ;
  uart_putc1( ((k/100) % 10)+48 ) ;
  uart_putc1( ((k/10) % 10)+48 ) ;
  uart_putc1( (k % 10)+48 ) ;
  uart_putc1(32) ;
  }

void chr_out(uint8_t v){
  uart_putc1(v) ; 
  }

void hex_out(uint8_t v){
  v &=0b00001111 ;
  if (v<=9) { chr_out('0'+v) ; } 
    else { chr_out(v+'A'-10) ; } ;
  }

void byte_out(uint8_t v){
  hex_out(v>>4) ; 
  hex_out(v) ; 
  }

void word_out(uint16_t v){
  byte_out(v>>8) ; 
  byte_out(v) ; 
  }

//------------------------------------------------------------------------------------------------------
#define scopeXsize 300
#define scopeYsize 100
#define scopeX0 10
#define scopeY0 10
#define scopeColor  ILI9341_WHITE 
#define scopeBackground  ILI9341_DARKGREEN 

int scopeX ;
int scopeYi[scopeXsize] ;

void scopeInit(){
  tftRectf(scopeX0, scopeY0, scopeXsize, scopeYsize, scopeBackground ) ;
  scopeX=0 ;
  for(int k=0 ; k<scopeXsize ; k++){
    scopeYi[k]=0 ;
    }
  }

void doScope(int y){
  static int lastY=0 ;
  if(y<0){ y=0 ; }
  if(y>=scopeYsize){ y=scopeYsize-1 ; }
  y += scopeY0 ;
  if(scopeX>0){
    tftLine(scopeX0+scopeX-1,lastY,scopeX0+scopeX,scopeYi[scopeX],scopeBackground) ;
    tftLine(scopeX0+scopeX-1,scopeYi[scopeX-1],scopeX0+scopeX,y,scopeColor) ;
    }
  lastY=scopeYi[scopeX] ;
  scopeYi[scopeX]=y ;
  scopeX++ ;
  if(scopeX>=scopeXsize){ scopeX=0 ; }
  }

//------------------------------------------------------------------------------------------------------

void adc_initOLD(void) {
  // ADC is in an unknown state. We should start by resetting it
  reset_block(RESETS_RESET_ADC_BITS);
  unreset_block_wait(RESETS_RESET_ADC_BITS);
  // Now turn it back on. Staging of clock etc is handled internally
  adc_hw->cs = ADC_CS_EN_BITS;
  // Internal staging completes in a few cycles, but poll to be sure
  while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
    tight_loop_contents();
    }
  }

void adc_init(void) {
    // ADC is in an unknown state. We should start by resetting it
    reset_block(RESETS_RESET_ADC_BITS);
    unreset_block_wait(RESETS_RESET_ADC_BITS);
    // Now turn it back on. Staging of clock etc is handled internally
    adc_hw->cs = ADC_CS_EN_BITS;
    // Internal staging completes in a few cycles, but poll to be sure
    while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
        tight_loop_contents();
    }
}

// int sampleTime=0 ;
int Isum,Qsum ;
static volatile int Ival,Qval ;
int inputVal ;

//----------------------------------------------------------------------------------------  
  
float dBfun(float x){
  if(x<1e-10) { return -10000 ; }
  return 20.0*log(fabs(x)) ;
  }
  
float dBasY(float v){
  return 90+1.0*(dBfun(v)+50.0) ;
  }

void showSpec1(){
  float xLast,yLast,y ;
  char sbuf[1024] ;
  printf("B  B\n") ; sleep_ms(100) ;
  graphFrame() ;
  sprintf(sbuf," f: %8d .. %8d Hz",(int)(fMin+fMix),(int)(fMax+fMix)) ;
  cursorY=-5 ;  cursorX=2 ;  tftPrint(sbuf) ;

  printf("M10;780;\n") ;
  printf("T%c%s%c\n",'"',sbuf,'"') ;
  xLast=0 ;
  yLast=0 ;
  y=dBasY( 1) ; tftLine(0,y,tftWidth,y,ILI9341_WHITE) ; cursorX=2 ;  cursorY=y-1 ; tftPrint("0") ; 
  y=dBasY(10) ; tftLine(0,y,tftWidth,y,ILI9341_WHITE) ; cursorX=2 ;  cursorY=y-1 ; tftPrint("20") ; 
  y=dBasY(100) ; tftLine(0,y,tftWidth,y,ILI9341_WHITE) ; cursorX=2 ;  cursorY=y-1 ; tftPrint("40") ; 
  y=dBasY(1000) ; tftLine(0,y,tftWidth,y,ILI9341_WHITE) ; cursorX=2 ;  cursorY=y-1 ; tftPrint("60") ; 
  cursorX=2 ; cursorY=tftHeight-20 ; tftPrint("dBmV") ; 
  //y=dBasY(10000) ; tftLine(0,y,xSize,y,ILI9341_WHITE) ; cursorY=2 ;  cursorX=y-10 ; tft_print("80") ; 
  //y=dBasY(100000) ; tftLine(0,y,xSize,y,ILI9341_WHITE) ; cursorY=2 ;  cursorX=y-10 ; tft_print("100") ; 
  int kMin=(int)(fMin/fFFTsample*nFFT) ;
  int kMin1=kMin ;
  if (kMin<=-nFFT/2){ kMin=-nFFT/2+1 ; }
  int kMax=(int)(fMax/fFFTsample*nFFT) ;
  int kMax1=kMax ;
  if (kMax>=nFFT/2){ kMax=nFFT/2-1 ; } ;

  int kCursor1=(int)(fCursor1/fFFTsample*nFFT) ;
  //printf("kCursor1=%10d\n",kCursor1) ;
  int x1=(int)(tftWidth* ((float)(kCursor1-kMin1))/((float)(kMax1-kMin1))) ;
  brokenLine(x1,20,x1,tftHeight,10,ILI9341_BLUE) ;

  x1=dd+(int)((xSize-2*dd)* ((float)(kCursor1-kMin1))/((float)(kMax1-kMin1))) ;
  BLine(x1,dd,x1,ySize-dd,10) ;


  //printf("x1=%10d\n",x1) ;
 
 /* 
   printf("fSample   =%10.1f Hz\n",fSample) ;
   printf("fFFTsample=%10.1f Hz\n",fFFTsample) ;
   printf("fMix      =%10.1f Hz\n",fMix) ;
   printf("Cursor1   =%10.1f Hz (%10.1f Hz)\n",(float)fCursor1,(float)(fCursor1+fMix)) ;
   printf("Cursor2   =%10.1f Hz (%10.1f Hz)\n",(float)fCursor2,(float)(fCursor2+fMix)) ;
 */
  

  int kCursor2=(int)(fCursor2/fFFTsample*nFFT) ;
  //printf("kCursor2=%10d\n",kCursor2) ;
  int x2=(int)(tftWidth* ((float)(kCursor2-kMin1))/((float)(kMax1-kMin1))) ;
  brokenLine(x2,20,x2,tftHeight,10,ILI9341_BLUE) ;

  x2=dd+(int)((xSize-2*dd)* ((float)(kCursor2-kMin1))/((float)(kMax1-kMin1))) ;
  BLine(x2,dd,x2,ySize-dd,10) ;

  //printf("x2=%10d\n",x2) ;
  //printf("fFFTsample=%10.2f Hz\n",fFFTsample) ;
  

  float vMax=0 ;
  int kMaxV=0 ;
  int xMax=0 ;
  int yMax=0 ;

  int jj=0 ;

 // float fft1Max=0.0 ;

 // printf("kMin=%d kMax=%d\n",kMin,kMax) ;
  for(int k=kMin ; k<kMax ; k++){
    int k1=k ; if(k1<0){ k1=nFFT+k ; }
    float v=sqrt(sqr(fftRe[k1])+sqr(fftIm[k1])) ;
   // if(v>fft1Max){ fft1Max=v ; }
    v *= 353.0/127000.0 ; // Vrms
    float y=dBasY(v) ;
    if(y<20){ y=20 ; }
    float x=tftWidth* ((float)(k-kMin1))/((float)(kMax1-kMin1)) ;
   // if(jj<20){ jj++ ; printf("v=%10.3f x=%10.3f y=%10.3f\n",v,x,y) ;  }
    if(v>vMax){ 
       vMax=v ; 
       xMax=x ;
       yMax=y ;
       kMaxV=k ;
       }
    if(k>kMin) { tftLine((int)xLast,(int)yLast,(int)x,(int)y,ILI9341_YELLOW) ; }
    xLast=x ; yLast=y ;
    }

printf("S255;255;0;\n") ;
int xx2=0 ;
int yy2=0 ;
float vvMax=0 ;
int xxMax=0 ;
int yyMax=0 ;
for(int k=kMin ; k<kMax ; k++){
    int k1=k ; if(k1<0){ k1=nFFT+k ; }
    float v=sqrt(sqr(fftRe[k1])+sqr(fftIm[k1])) ;
   // if(v>fft1Max){ fft1Max=v ; }
    v *= 353.0/127000.0 ; // Vrms
    int xx1=dd+((xSize-2*dd)* ((float)(k-kMin1))/((float)(kMax1-kMin1))) ;
    int yy1=yOfS(v) ;
     if(v>vvMax){ 
       vvMax=v ; 
       xxMax=xx1 ;
       yyMax=yy1 ;
       }
    if(k>kMin) { LLine(xx2,yy2,xx1,yy1) ; }
    xx2=xx1 ; yy2=yy1 ;
    }
  LLine(xxMax-5,yyMax-5,xxMax+5,yyMax+5) ;
  LLine(xxMax-5,yyMax+5,xxMax+5,yyMax-5) ;


  tftLine(xMax-5,yMax-5,xMax+5,yMax+5,rgb(255,255,255)) ;
  tftLine(xMax-5,yMax+5,xMax+5,yMax-5,rgb(255,255,255)) ;
  float fMax=fFFTsample*kMaxV/((float)nFFT) ;

 // printf("\nMax at k=%d  frq=%10.3f Hz (%10.3f Hz)\n",kMaxV,fMax,fMax+fMix) ;
  //printf("\nfft1Max =%10.3f \n",fft1Max) ;
 // printf("max v = %10.4f mVrms sqrt(2)*2*vMax/1000=%10.4f Vpp\n",vMax,sqrt(2)*2*vMax/1000.0) ;

  sprintf(sbuf,"Max at f=%8.1f Hz %8.1f mVrms",fMax+fMix,vMax) ;
  cursorY=300 ;  cursorX=60 ;  tftPrint(sbuf) ;

  printf("M10;20;\n") ;
  printf("T%c%s%c\n",'"',sbuf,'"') ;

  if(displayMax){
    for(int k=kMin ; k<kMax ; k++){
      int k1=k ; if(k1<0){ k1=nFFT+k ; }       
      float v=fftMax[k1] ;
      v *= 353.0/127000.0 ; // Vrms
      float y=dBasY(v) ;
      float x=tftWidth* ((float)(k-kMin1))/((float)(kMax1-kMin1)) ;
      if(k>kMin) { tftLine((int)xLast,(int)yLast,(int)x,(int)y,ILI9341_PINK) ; }
      xLast=x ; yLast=y ;
      }
    } 
  printf("S0;0;255;\n") ;
  xx2=0 ;
  yy2=0 ;
  for(int k=kMin ; k<kMax ; k++){
    int k1=k ; if(k1<0){ k1=nFFT+k ; }
    float v=fftMax[k1] ;
    v *= 353.0/127000.0 ; // Vrms
    int xx1=dd+((xSize-2*dd)* ((float)(k-kMin1))/((float)(kMax1-kMin1))) ;
    int yy1=yOfS(v) ;
    if(k>kMin) { LLine(xx2,yy2,xx1,yy1) ; }
    xx2=xx1 ; yy2=yy1 ;
    }
  }

void getBuffer() {
  uint32_t state ;
  int adc ;
  int adcMean ;
  printf("sampling %d samples...\n",nFFT) ;
  adc_fifo_setup(true, false, 0, false, false);
  adc_run(true);
  state=save_and_disable_interrupts () ;
  mixDDSp=0 ;
  adcMean=0 ;
  for (int k = 0; k < 512 ; k++ ){
    adc_fifo_get_blocking();
    }
  // gpio_put(GPIO4, 1);
  if(nDown==1){
    for (int k = 0; k < nFFT ; k++ ){
      adc=adc_fifo_get_blocking() ;
      adcMean += adc ;
      if(fMix==0){
        fftRe[k]=adc-2048 ;
        fftIm[k]=0 ;
        }
       else {
        int inputVal=adc-2048 ;
        mixDDSp += mixDDSd ; 
        fftRe[k] = LOcosTab[mixDDSp>>24]*inputVal ;
        fftIm[k] = LOsinTab[mixDDSp>>24]*inputVal ;
        } 
      }
    }
   else { 
    for (int k = 0; k < nFFT ; k++ ){
      Isum=0 ;
      Qsum=0 ;
      for(int k2=0 ; k2<nDown ; k2++){
        mixDDSp += mixDDSd ; 
        adc=adc_fifo_get_blocking() ;
        adcMean += adc ;
        int inputVal=adc-2048 ;
        if(fMix!=0){
          if(downSum){
            Isum += LOcosTab[mixDDSp>>24]*inputVal ;
            Qsum += LOsinTab[mixDDSp>>24]*inputVal ;
            }
           else  {
            Isum = LOcosTab[mixDDSp>>24]*inputVal ;
            Qsum = LOsinTab[mixDDSp>>24]*inputVal ;
            }
          }
         else {
          if(downSum){ 
            Isum += inputVal ;
            Qsum += 0 ;
            }
          else { 
            Isum = inputVal ;
            Qsum = 0 ;
            }
          } 
        }
      fftRe[k]=Isum ; 
      fftIm[k]=Qsum ;
      }
    }
  adcMean=adcMean/nFFT ;
  adcMean=adcMean/nDown ;
  printf("after sampling: raw adcmean=%d\n",adcMean) ;
  float s=1.0 ;
  if(downSum){ s=s/nDown ; }
  if(fMix!=0){ s=s/LOscale ; }
  //printf("s=%10.6f\n",s) ;

  for (int k = 0; k < nFFT ; k++ ){ 
     fftRe[k] *= s ;
     fftIm[k] *= s ; 
//     if(k<100){ printf("k=%3d fftRe=%10.3f fftIm=%10.3f\n",k,fftRe[k],fftIm[k]) ; }
     }
  restore_interrupts (state) ;
  // gpio_put(GPIO4, 0);
  adc_run(false);
  adc_fifo_drain();
  }

float mvolts(float x){
  return 3.3/2.0*x/2048.0*1000.0 ;
}

void showBuffer(){
  // fillRectOssi2(0, 0, xSize, ySize, ILI9341_BLACK ) ;
  getBuffer() ;
  float Imean=0 ;
  float Qmean=0 ;
  float Imax,Imin ;
  float Qmax,Qmin ;
  Imax=-1e20 ; Imin=1e20 ;
  Qmax=-1e20 ; Qmin=1e20 ;

  for(int k=0 ; k<nFFT ; k++){
    //printf("%10.3f\n",fftRe[k]) ;
    Imean += fftRe[k] ;
    Qmean += fftIm[k] ;
    if(fftRe[k]>Imax){ Imax=fftRe[k] ; }
    if(fftRe[k]<Imin){ Imin=fftRe[k] ; }
    if(fftIm[k]>Qmax){ Qmax=fftIm[k] ; }
    if(fftIm[k]<Qmin){ Qmin=fftIm[k] ; }
    }
  Imean=Imean/nFFT ;
  Qmean=Qmean/nFFT ;
  float Irms=0 ;
  float Qrms=0 ;
  for(int k=0 ; k<nFFT ; k++){
    fftRe[k] -= Imean ;
    fftIm[k] -= Qmean ;
    Irms += sqr(fftRe[k]) ;
    Qrms += sqr(fftIm[k]) ;
    }
  Irms=sqrt(Irms/nFFT) ;
  Qrms=sqrt(Qrms/nFFT) ;
  
  //printf("\n\n") ;
  /*
  printf("Imin =%10.3f  Imax=%10.3f \n",Imin,Imax) ;
  printf("Qmin =%10.3f  Qmax=%10.3f \n",Qmin,Qmax) ;
  printf("Imean=%10.3f  Irms=%10.3f \n",Imean,Irms) ;
  printf("Qmean=%10.3f  Qrms=%10.3f \n\n",Qmean,Qrms) ;
  */
/*
  printf("Imin =%10.3f mV Imax=%10.3f mV\n",mvolts(Imin),mvolts(Imax)) ;
  printf("Qmin =%10.3f mV Qmax=%10.3f mV\n",mvolts(Qmin),mvolts(Qmax)) ;
  printf("Imean=%10.3f mV Irms=%10.3f mV\n",mvolts(Imean),mvolts(Irms)) ;
  printf("Qmean=%10.3f mV Qrms=%10.3f mV\n\n",mvolts(Qmean),mvolts(Qrms)) ;
*/


  if(0){
    for(int k=0 ; k<tftWidth ; k++){
      float v=(fftRe[k]) ;
      float y=tftHeight/2+0.5*v ;
      if(k>0) { tftLine((int)xLast,(int)yLast,k,(int)y,ILI9341_WHITE) ; }
      xLast=k ; yLast=y ;
      }
    }  
  //sleep_ms(2000) ;
  windowedFFT(1 , scale1/nFFT ) ;
  tftClear(ILI9341_BLACK ) ;
  tftLine(0,0,0,320,ILI9341_WHITE) ; 
  
  for(int k=0 ; k<nFFT ; k++){
    float v=sqrt(sqr(fftRe[k])+sqr(fftIm[k])) ;
    if(v>fftMax[k]){ fftMax[k]=v ; }
    }
  showSpec1() ;
  approxSleepMs(2000) ;
  }  

//----------------------------------------------------------------------------------------  




int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);

  // PWMsetup() ;
  fSample=500000.0 ;
  fFFTsample=fSample/nDown ;
  printf("fSample=%15.5f\n",fSample) ;
  printf("fFFTsample=%15.5f\n",fFFTsample) ;

  tftSetup() ;
  sigSetup() ;
 
  scopeInit() ;
 
  IIfil=butter(2,50.0/800.0) ;
  QQfil=butter(2,50.0/800.0) ;

  approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello SpecAnaToTFTandHardwareUartV02 !\n") ;
  
  toggle=0 ;
   
  double DDSfrq=fMix ;
  printf("fSample=%15.5f\n",fSample) ;
  adc_init();
  // Make sure GPIO is high-impedance, no pullups etc

  
// Select ADC input 2 (GPIO28)
  adc_gpio_init(28);
  adc_select_input(2);

  mixDDSp =0 ;
  mixDDSd=(int)( 4294967296.0*DDSfrq/fSample) ;

  simDDSp =0 ;
  simDDSd=(int)( 4294967296.0*fSim/fSample) ;
    
  for(int k=0 ; k<nFFT ; k++){
    fftMax[k]=0 ;
    }

  sigSetup() ;
  showMean() ;

  while (1){
    showBuffer() ;
    }
 

  }

